/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
	"time"
)

// checks if the CreateCveIdsPartialResponseCveIdsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveIdsPartialResponseCveIdsInner{}

// CreateCveIdsPartialResponseCveIdsInner struct for CreateCveIdsPartialResponseCveIdsInner
type CreateCveIdsPartialResponseCveIdsInner struct {
	CveId *string `json:"cve_id,omitempty"`
	CveYear *string `json:"cve_year,omitempty"`
	// The shortname for the organization that owns the CVE ID
	OwningCna *string `json:"owning_cna,omitempty"`
	State *string `json:"state,omitempty"`
	RequestedBy *ListCveIdsResponseCveIdsInnerRequestedBy `json:"requested_by,omitempty"`
	// The time the ID was reserved
	Reserved *time.Time `json:"reserved,omitempty"`
}

// NewCreateCveIdsPartialResponseCveIdsInner instantiates a new CreateCveIdsPartialResponseCveIdsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveIdsPartialResponseCveIdsInner() *CreateCveIdsPartialResponseCveIdsInner {
	this := CreateCveIdsPartialResponseCveIdsInner{}
	return &this
}

// NewCreateCveIdsPartialResponseCveIdsInnerWithDefaults instantiates a new CreateCveIdsPartialResponseCveIdsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveIdsPartialResponseCveIdsInnerWithDefaults() *CreateCveIdsPartialResponseCveIdsInner {
	this := CreateCveIdsPartialResponseCveIdsInner{}
	return &this
}

// GetCveId returns the CveId field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetCveId() string {
	if o == nil || IsNil(o.CveId) {
		var ret string
		return ret
	}
	return *o.CveId
}

// GetCveIdOk returns a tuple with the CveId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetCveIdOk() (*string, bool) {
	if o == nil || IsNil(o.CveId) {
		return nil, false
	}
	return o.CveId, true
}

// HasCveId returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) HasCveId() bool {
	if o != nil && !IsNil(o.CveId) {
		return true
	}

	return false
}

// SetCveId gets a reference to the given string and assigns it to the CveId field.
func (o *CreateCveIdsPartialResponseCveIdsInner) SetCveId(v string) {
	o.CveId = &v
}

// GetCveYear returns the CveYear field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetCveYear() string {
	if o == nil || IsNil(o.CveYear) {
		var ret string
		return ret
	}
	return *o.CveYear
}

// GetCveYearOk returns a tuple with the CveYear field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetCveYearOk() (*string, bool) {
	if o == nil || IsNil(o.CveYear) {
		return nil, false
	}
	return o.CveYear, true
}

// HasCveYear returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) HasCveYear() bool {
	if o != nil && !IsNil(o.CveYear) {
		return true
	}

	return false
}

// SetCveYear gets a reference to the given string and assigns it to the CveYear field.
func (o *CreateCveIdsPartialResponseCveIdsInner) SetCveYear(v string) {
	o.CveYear = &v
}

// GetOwningCna returns the OwningCna field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetOwningCna() string {
	if o == nil || IsNil(o.OwningCna) {
		var ret string
		return ret
	}
	return *o.OwningCna
}

// GetOwningCnaOk returns a tuple with the OwningCna field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetOwningCnaOk() (*string, bool) {
	if o == nil || IsNil(o.OwningCna) {
		return nil, false
	}
	return o.OwningCna, true
}

// HasOwningCna returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) HasOwningCna() bool {
	if o != nil && !IsNil(o.OwningCna) {
		return true
	}

	return false
}

// SetOwningCna gets a reference to the given string and assigns it to the OwningCna field.
func (o *CreateCveIdsPartialResponseCveIdsInner) SetOwningCna(v string) {
	o.OwningCna = &v
}

// GetState returns the State field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetState() string {
	if o == nil || IsNil(o.State) {
		var ret string
		return ret
	}
	return *o.State
}

// GetStateOk returns a tuple with the State field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetStateOk() (*string, bool) {
	if o == nil || IsNil(o.State) {
		return nil, false
	}
	return o.State, true
}

// HasState returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) HasState() bool {
	if o != nil && !IsNil(o.State) {
		return true
	}

	return false
}

// SetState gets a reference to the given string and assigns it to the State field.
func (o *CreateCveIdsPartialResponseCveIdsInner) SetState(v string) {
	o.State = &v
}

// GetRequestedBy returns the RequestedBy field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetRequestedBy() ListCveIdsResponseCveIdsInnerRequestedBy {
	if o == nil || IsNil(o.RequestedBy) {
		var ret ListCveIdsResponseCveIdsInnerRequestedBy
		return ret
	}
	return *o.RequestedBy
}

// GetRequestedByOk returns a tuple with the RequestedBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetRequestedByOk() (*ListCveIdsResponseCveIdsInnerRequestedBy, bool) {
	if o == nil || IsNil(o.RequestedBy) {
		return nil, false
	}
	return o.RequestedBy, true
}

// HasRequestedBy returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) HasRequestedBy() bool {
	if o != nil && !IsNil(o.RequestedBy) {
		return true
	}

	return false
}

// SetRequestedBy gets a reference to the given ListCveIdsResponseCveIdsInnerRequestedBy and assigns it to the RequestedBy field.
func (o *CreateCveIdsPartialResponseCveIdsInner) SetRequestedBy(v ListCveIdsResponseCveIdsInnerRequestedBy) {
	o.RequestedBy = &v
}

// GetReserved returns the Reserved field value if set, zero value otherwise.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetReserved() time.Time {
	if o == nil || IsNil(o.Reserved) {
		var ret time.Time
		return ret
	}
	return *o.Reserved
}

// GetReservedOk returns a tuple with the Reserved field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) GetReservedOk() (*time.Time, bool) {
	if o == nil || IsNil(o.Reserved) {
		return nil, false
	}
	return o.Reserved, true
}

// HasReserved returns a boolean if a field has been set.
func (o *CreateCveIdsPartialResponseCveIdsInner) HasReserved() bool {
	if o != nil && !IsNil(o.Reserved) {
		return true
	}

	return false
}

// SetReserved gets a reference to the given time.Time and assigns it to the Reserved field.
func (o *CreateCveIdsPartialResponseCveIdsInner) SetReserved(v time.Time) {
	o.Reserved = &v
}

func (o CreateCveIdsPartialResponseCveIdsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveIdsPartialResponseCveIdsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.CveId) {
		toSerialize["cve_id"] = o.CveId
	}
	if !IsNil(o.CveYear) {
		toSerialize["cve_year"] = o.CveYear
	}
	if !IsNil(o.OwningCna) {
		toSerialize["owning_cna"] = o.OwningCna
	}
	if !IsNil(o.State) {
		toSerialize["state"] = o.State
	}
	if !IsNil(o.RequestedBy) {
		toSerialize["requested_by"] = o.RequestedBy
	}
	if !IsNil(o.Reserved) {
		toSerialize["reserved"] = o.Reserved
	}
	return toSerialize, nil
}

type NullableCreateCveIdsPartialResponseCveIdsInner struct {
	value *CreateCveIdsPartialResponseCveIdsInner
	isSet bool
}

func (v NullableCreateCveIdsPartialResponseCveIdsInner) Get() *CreateCveIdsPartialResponseCveIdsInner {
	return v.value
}

func (v *NullableCreateCveIdsPartialResponseCveIdsInner) Set(val *CreateCveIdsPartialResponseCveIdsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveIdsPartialResponseCveIdsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveIdsPartialResponseCveIdsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveIdsPartialResponseCveIdsInner(val *CreateCveIdsPartialResponseCveIdsInner) *NullableCreateCveIdsPartialResponseCveIdsInner {
	return &NullableCreateCveIdsPartialResponseCveIdsInner{value: val, isSet: true}
}

func (v NullableCreateCveIdsPartialResponseCveIdsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveIdsPartialResponseCveIdsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


